if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_MyCalls_Get' ) )
	Drop procedure dbo.A_Stat_MyCalls_Get
GO

Create procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'

*/
	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 100 ) collate database_default, 
				IsRecorded int, IdRecDir int, ALineNum nvarchar ( 5 ) collate database_default, BLineNum nvarchar ( 5 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 100 ) collate database_default, BStr nvarchar ( 100 ) collate database_default )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '',
			IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr
		From A_Stat_Connections_1x1 sc --with ( TabLock )
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From @output o
	Where o.AbonentName = o.Number


	Select Id, IdChain, Media, Type, TimeStart, Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir--, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc
end
GO
