if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_MissedCalls' ) )
	Drop table A_Stat_MissedCalls
GO

Create Table dbo.A_Stat_MissedCalls
(
	--
	Id uniqueidentifier,

	--
	MissDateTime DateTime,

	--
	IdChain uniqueidentifier,

	--
	AUserId uniqueidentifier,
	ALineId uniqueidentifier,
	AOutNumber nvarchar ( 50 ),
	AStr nvarchar ( 200 ),	

	--
	NumberDialed nvarchar ( 50 ),

	-- 
	BUserId uniqueidentifier,
	BLineId uniqueidentifier,

	-- 
	BReason int,

	--   
	Handled bit,
	HUserId uniqueidentifier,
	HLineId uniqueidentifier,
	HOutNumber nvarchar ( 50 ),
	HStr nvarchar ( 200 ),
	HIdConn uniqueidentifier	
)
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_MissedCalls_Add' ) )
	Drop procedure A_Stat_MissedCalls_Add
GO

Create procedure dbo.A_Stat_MissedCalls_Add
	@id uniqueidentifier, 
	@dt datetime, 
	@idchain uniqueidentifier, 
	@auserid uniqueidentifier, 
	@alineid uniqueidentifier, 
	@aoutnumber nvarchar ( 50 ), 
	@astr nvarchar ( 200 ), 
	@numdialed nvarchar ( 50 ), 
	@buserid uniqueidentifier, 
	@blineid uniqueidentifier, 
	@breason int,
	@handled bit, 
	@huserid uniqueidentifier, 
	@hlineid uniqueidentifier, 
	@houtnumber nvarchar ( 50 ), 
	@hstr nvarchar ( 200 ), 
	@hidconn uniqueidentifier
as
begin
	Insert into A_Stat_MissedCalls
		( Id, MissDateTime, IdChain,
		AUserId, ALineId, AOutNumber, AStr, 
		NumberDialed, BUserId, BLineId, BReason,
		Handled, HUserId, HLineId, HOutNumber, HStr, HIdConn )
	Values
		( @id, @dt, @idchain, 
		@auserid, @alineid, @aoutnumber, @astr, 
		@numdialed, @buserid, @blineid, @breason,
		@handled, @huserid, @hlineid, @houtnumber, @hstr, @hidconn )
end
GO