/*------------------------------------------------------------------------------------------*/
/* */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_Roles' ) )
	Drop Table dbo.A_UserRoles_Roles
GO
/*  */
Create Table dbo.A_UserRoles_Roles
(
 	Id uniqueidentifier Primary Key Not Null,
	Name nvarchar (200) Not Null,		/* */
	BaseRole uniqueidentifier,		/*Id  */
	Domination bit Not Null			/* */
)
GO
/*------------------------------------------------------------------------------------------*/
/* */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_Rights' ) )
	Drop Table dbo.A_UserRoles_Rights
GO
/*  */
Create Table dbo.A_UserRoles_Rights
(
 	Id uniqueidentifier Primary Key Not Null,
	Knot nvarchar (100) Not Null,	/*  */
	Name nvarchar (200) Not Null,	/* */
	Code nvarchar (100) Not Null	/* */
)
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_RightsOfRoles' ) )
	Drop Table dbo.A_UserRoles_RightsOfRoles
GO

Create Table dbo.A_UserRoles_RightsOfRoles
(
 	IdRole uniqueidentifier Not Null,	/*ID */
 	IdRight uniqueidentifier Not Null,	/*ID */
 	Value int Not Null			/* "0"-, "1"-, "-1"-*/
)
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_RolesOfUsers' ) )
	Drop Table dbo.A_UserRoles_RolesOfUsers
GO

Create Table dbo.A_UserRoles_RolesOfUsers
(
 	IdUser uniqueidentifier Not Null,	/*ID  */
 	IdRole uniqueidentifier Not Null,	/*ID */
)
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_Load_RightsOfRoles' ) )
	Drop Procedure dbo.A_UserRoles_Load_RightsOfRoles
GO

Create Procedure dbo.A_UserRoles_Load_RightsOfRoles
As
Begin
	Select IdRole, b.Code, Value From dbo.A_UserRoles_RightsOfRoles a
	left join
	(
		Select * From A_UserRoles_Rights
	) b
	On a.IdRight = b.id
End
GO
/*------------------------------------------------------------------------------------------*/
/*    -  */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_GetRightsFromRole' ) )
	Drop Procedure dbo.A_UserRoles_GetRightsFromRole
GO

Create Procedure dbo.A_UserRoles_GetRightsFromRole
	@IdRole uniqueidentifier
As
Begin
	Select b.Code, Value From dbo.A_UserRoles_RightsOfRoles a
	left join
	(
		Select * From A_UserRoles_Rights
	) b
	On a.IdRight = b.id
	Where IdRole = @IdRole
End
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_GetAllRights' ) )
	Drop Procedure dbo.A_UserRoles_GetAllRights
GO

Create Procedure dbo.A_UserRoles_GetAllRights
As
Begin
	Select * From dbo.A_UserRoles_Rights
End
GO
/*------------------------------------------------------------------------------------------*/
/*       */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_Load_Roles' ) )
	Drop Procedure dbo.A_UserRoles_Load_Roles
GO

Create Procedure dbo.A_UserRoles_Load_Roles
As
Begin
	Select Id, Name, BaseRole, Domination, UserCount From dbo.A_UserRoles_Roles a
	left join
	(
		Select IdRole, UserCount=Count ( * )
		From A_UserRoles_RolesOfUsers
		Group By IdRole
	) b
	On a.Id = b.IdRole
End
GO
/*------------------------------------------------------------------------------------------*/
/*  -  " "     "   "*/
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_RemoveRole' ) )
	Drop Procedure dbo.A_UserRoles_RemoveRole
GO

Create Procedure dbo.A_UserRoles_RemoveRole
	@id uniqueidentifier
As
Begin
	Delete from dbo.A_UserRoles_Roles
	Where Id = @id
	Delete from dbo.A_UserRoles_RightsOfRoles
	Where IdRole = @id
End
GO
/*------------------------------------------------------------------------------------------*/
/*    */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_SaveRole' ) )
     Drop Procedure dbo.A_UserRoles_SaveRole
GO

Create Procedure dbo.A_UserRoles_SaveRole
	@id uniqueidentifier,
	@name nvarchar (200),
	@baserole uniqueidentifier,
	@domination bit
As
begin
	Update dbo.A_UserRoles_Roles
	Set
		Id = @id,
		Name = @name,
		BaseRole = @baserole,
		Domination = @domination
	Where
		Id = @id

	if ( @@rowcount = 0 )
	Insert into dbo.A_UserRoles_Roles ( Id, Name, BaseRole, Domination ) Values ( @id, @name, @baserole, @domination )
end
GO
/*------------------------------------------------------------------------------------------*/
/*    */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_RemoveAllRightsFromRole' ) )
     Drop Procedure dbo.A_UserRoles_RemoveAllRightsFromRole
GO

Create Procedure dbo.A_UserRoles_RemoveAllRightsFromRole
	@idrole uniqueidentifier
As
begin
	Delete from dbo.A_UserRoles_RightsOfRoles
	Where IdRole = @idrole
end
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_AddRightForRole' ) )
     Drop Procedure dbo.A_UserRoles_AddRightForRole
GO

Create Procedure dbo.A_UserRoles_AddRightForRole
	@idrole uniqueidentifier,
	@idright uniqueidentifier,
	@value int
As
begin
	Insert Into dbo.A_UserRoles_RightsOfRoles values(@idrole, @idright, @value)
end
GO
/*------------------------------------------------------------------------------------------*/
/*     */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_RemoveAllRights' ) )
     Drop Procedure dbo.A_UserRoles_RemoveAllRights
GO

Create Procedure dbo.A_UserRoles_RemoveAllRights
As
begin
	Delete from dbo.A_UserRoles_Rights
end
GO
/*------------------------------------------------------------------------------------------*/
/*    */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_AddRight' ) )
     Drop Procedure dbo.A_UserRoles_AddRight
GO

Create Procedure dbo.A_UserRoles_AddRight
 	@id uniqueidentifier,
	@knot nvarchar (100),
	@name nvarchar (200),
	@code nvarchar (100)
As
begin
	Insert Into dbo.A_UserRoles_Rights values(@id, @knot, @name, @code)
end
GO
/*------------------------------------------------------------------------------------------*/
/*     */
if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_UserRoles_SetRoleForUser' ) )
     Drop Procedure dbo.A_UserRoles_SetRoleForUser
GO

Create Procedure dbo.A_UserRoles_SetRoleForUser
	@iduser uniqueidentifier,
	@idrole uniqueidentifier,
	@set bit
As
begin
	Delete from dbo.A_UserRoles_RolesOfUsers
	Where (IdRole = @idrole) And (IdUser = @iduser)

	if ( @set = 1 )
		Insert Into dbo.A_UserRoles_RolesOfUsers values(@iduser, @idrole)
end
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_Load_RolesOfUsers' ) )
	Drop Procedure dbo.A_UserRoles_Load_RolesOfUsers
GO

Create Procedure dbo.A_UserRoles_Load_RolesOfUsers
As
Begin
	Select IdUser, IdRole, b.Domination From dbo.A_UserRoles_RolesOfUsers a
	left join
	(
		select * from A_UserRoles_Roles
	) b
	On a.IdRole = b.Id
End
GO
/*------------------------------------------------------------------------------------------*/
/*    */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_RemoveRolesOfUser' ) )
	Drop Procedure dbo.A_UserRoles_RemoveRolesOfUser
GO

Create Procedure dbo.A_UserRoles_RemoveRolesOfUser
	@iduser uniqueidentifier
As
Begin
	Delete From dbo.A_UserRoles_RolesOfUsers where IdUser = @iduser
	Delete From dbo.A_UserRoles_Roles where Id = @iduser
	Delete From dbo.A_UserRoles_RightsOfRoles where IdRole = @iduser
End
GO
/*------------------------------------------------------------------------------------------*/
/*   */
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserRoles_SaveRoleForUser' ) )
	Drop Procedure dbo.A_UserRoles_SaveRoleForUser
GO

Create Procedure dbo.A_UserRoles_SaveRoleForUser
	@iduser uniqueidentifier,
	@idrole uniqueidentifier
As
Begin
	Insert into dbo.A_UserRoles_RolesOfUsers ( IdUser, IdRole ) Values ( @iduser, @idrole )
End
GO
