if exists ( select * From sysobjects where id = object_id ( 'dbo.A_DB_Optimize' ) )
	Drop procedure A_DB_Optimize
GO


Create procedure dbo.A_DB_Optimize
as
begin
	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	--  maxsize    1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )

	DBCC DBREINDEX ( 'dbo.A_CallCenter_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_CallCenter_ControlEventsJournal' )
	DBCC DBREINDEX ( 'dbo.A_ClientHistory' )
	DBCC DBREINDEX ( 'dbo.A_ICQMessages' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTaskNumbers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_Competitors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_RecordAccessUsers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_1x1' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_Errors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_DTMF' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_Algorythms' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_StopInfo' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_Task_IncomingCalls' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskNumber' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskEfforts' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_UserInTask' )
	DBCC DBREINDEX ( 'dbo.A_User_NotifyLog' )
	DBCC DBREINDEX ( 'dbo.A_UserMessages' )
	DBCC DBREINDEX ( 'dbo.A_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_VoiceMail' )
	
	DBCC SHRINKDATABASE (oktell)

	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )


	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	begin
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @msz != -1 and @msz < 1500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', maxsize=1500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )

		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_EffortConnections' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_OperatorStates' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_CallQueue' )

		DBCC SHRINKDATABASE (oktell_cc_temp)
		
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @sz < 500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', size=500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )
	end
end 
GO


if exists ( select * From sysobjects where id = object_id ( 'dbo.A_DB_OptimizeRemove' ) )
	Drop procedure A_DB_OptimizeRemove
GO


Create procedure dbo.A_DB_OptimizeRemove
	@days int = 2
as
begin
	--    
	declare @dt DateTime
	Set @dt = DateAdd ( d, -@days, GetDate () )
	select @dt = Cast ( FLOOR ( Cast ( @dt as float ) ) as DateTime )

	-- 
	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()

	--      
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	--  maxsize    1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )

	-- 
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	begin
		--       
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @msz != -1 and @msz < 1500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', maxsize=1500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )

		--     
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_EffortConnections' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_OperatorStates' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_CallQueue' )

		--   
		DBCC SHRINKDATABASE (oktell_cc_temp)
	
		--          
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @sz < 500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', size=500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )
	end

	--    
	Delete From dbo.A_CallBackOrders Where CalledDateTime < @dt
	Delete From dbo.A_CallCenter_UserStateHistory Where TimeEnter < @dt
	Delete From dbo.A_ICQMessages Where date_receive < @dt
	Delete From dbo.A_Stat_Connections_1x1 Where TimeStart < @dt
	Delete From dbo.A_Stat_Connections_Errors Where TimeStart < @dt
	Delete From dbo.A_Stat_Conference Where TimeStart < @dt
	Delete From dbo.A_Stat_Conference_Competitors Where not exists ( Select IdConf From A_Stat_Conference Where Id = IdConf )
	Delete From dbo.A_Stat_Conference_RecordAccessUsers Where not exists ( Select IdConf From A_Stat_Conference Where Id = IdConf )
	Delete From dbo.A_Stat_Talk_Algorythms Where not exists ( Select IdChain From A_Stat_Connections_1x1 Where IdChain = IdConnection )
	Delete From dbo.A_Stat_Talk_StopInfo Where TimeStop < @dt
	Delete From dbo.A_TaskManager_Task_IncomingCalls Where CallTimeStart < @dt
	Delete From dbo.A_TaskManager_SubTaskEfforts Where EDateTime < @dt
	Delete From dbo.A_TaskManager_UserInTask Where TimeStart < @dt
	Delete From dbo.A_User_NotifyLog Where NotifyDateTime < @dt
	Delete From dbo.A_UserMessages Where SentDate < @dt
	Delete From dbo.A_UserStateHistory Where TimeChange < @dt
	Delete From dbo.A_VoiceMail Where SentTime < @dt

	--  
	DBCC DBREINDEX ( 'dbo.A_CallCenter_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_CallCenter_ControlEventsJournal' )
	DBCC DBREINDEX ( 'dbo.A_ClientHistory' )
	DBCC DBREINDEX ( 'dbo.A_ICQMessages' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTaskNumbers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_Competitors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_RecordAccessUsers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_1x1' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_Errors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_DTMF' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_Algorythms' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_StopInfo' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_Task_IncomingCalls' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskNumber' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskEfforts' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_UserInTask' )
	DBCC DBREINDEX ( 'dbo.A_User_NotifyLog' )
	DBCC DBREINDEX ( 'dbo.A_UserMessages' )
	DBCC DBREINDEX ( 'dbo.A_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_VoiceMail' )
	
	--  
	DBCC SHRINKDATABASE (oktell)

	--        
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )
end
GO

