if exists ( Select * from sysobjects where id=object_id('dbo.A_CallBackOrders_Journal_Get'))
	Drop procedure dbo.A_CallBackOrders_Journal_Get
GO

Create Procedure [dbo].[A_CallBackOrders_Journal_Get]
	@userid		uniqueidentifier,
	@onlynotviewed	bit,
	@onlynotdone	bit
as
begin

/*
-- --
declare @userid uniqueidentifier
declare @onlynotviewed bit
declare @onlynotdone bit

set @userid = '2A594B51-BB89-4DA6-A69F-F48761BAF0D9'
set @onlynotviewed = 0
set @onlynotdone = 0
------------------
*/

	declare @numbers table ( Prefix nvarchar ( 20 ) collate database_default)
	Insert into @numbers
	    Select np.Prefix
	    From A_NumberPlan np
		Inner join A_NumberPlanAction npa on np.Id = npa.NumId
		Inner join A_Rules r on npa.ExtraId = r.Id
		Inner join A_RuleRecords rr on rr.RuleId = r.Id
	    Where rr.ReactId = @userid
	    Group by np.Prefix
	


	declare @list table 
	( IDconn 	uniqueidentifier,
	  ClientId 	uniqueidentifier,
	  CalledDateTime DateTime,
	  IsOrderedTime bit,
	  OrderedTime 	DateTime,
	  OrderedNumber	nvarchar ( 50 ) COLLATE database_default,
	  IsSpecifiedReciever bit,
	  Comment 	nvarchar ( 1000 ) COLLATE database_default,
	  Done 		bit,
	  DoneUserId	uniqueidentifier,
	  Viewed 	bit,
	  ClientName 	nvarchar ( 200 ) COLLATE database_default,
	  DoneUserName  nvarchar ( 500 ) COLLATE database_default
	)

	Insert Into @list
	    Select a.*, cl.Name, u.Name
  	    From
	    (	
		Select 	cbo.IDconn, cbo.ClientId, cbo.CalledDateTime, cbo.IsOrderedTime, cbo.OrderedTime, cbo.OrderedNumber, 
			cbo.IsSpecifiedReciever, cbo.Comment, cbo.Done, cbo.DoneUserId, cbo.Viewed
		From A_CallBackOrders cbo		
		Where IsSpecifiedReciever = 0
			And ( ( Done = 0 ) or ( @onlynotdone = 0 ) )
			And ( ( Viewed = 0 ) or ( @onlynotviewed = 0 ) )

		Union All

		Select 	cbo.IDconn, cbo.ClientId, cbo.CalledDateTime, cbo.IsOrderedTime, cbo.OrderedTime, cbo.OrderedNumber, 
			cbo.IsSpecifiedReciever, cbo.Comment, cbo.Done, cbo.DoneUserId, cbo.Viewed
		From A_CallBackOrders cbo
			Inner join A_CallBackRecievers cbr on cbo.Idconn = cbr.Idconn
			Inner join @numbers n on cbr.IntNumber = n.Prefix
		Where IsSpecifiedReciever = 1
			And ( ( Done = 0 ) or ( @onlynotdone = 0 ) )
			And ( ( Viewed = 0 ) or ( @onlynotviewed = 0 ) )
	    )a
		Left join A_Clients cl on a.ClientId = cl.Id
		Left join A_Users u on a.DoneUserId = u.Id



	Update A_CallBackOrders 
	Set A_CallBackOrders.Viewed = 1 
	From A_CallBackOrders, @list lst
	Where A_CallBackOrders.IdConn = lst.IdConn



	Select * 
	From @list
	Order by Viewed, Done, CalledDateTime Desc
	
end
GO
