if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Service_StatRemove' ) )
	Drop procedure dbo.A_Service_StatRemove
GO

Create procedure dbo.A_Service_StatRemove
	@pbxdrop bit,
	@pbxdropfiles bit,
	@pbxfromdate DateTime,
	@ccdrop bit,
	@ccdropfiles bit,
	@ccfromdate DateTime,
	@dropped int OUTPUT
as
begin

--
/*
declare @pbxdrop bit
declare @pbxdropfiles bit
declare @pbxfromdate DateTime
declare @ccdrop bit
declare @ccdropfiles bit
declare @ccfromdate DateTime
declare @dropped int

set @pbxdrop = 0
set @pbxdropfiles = 1
set @pbxfromdate = '01.05.2007'
set @ccdrop = 0
set @ccdropfiles = 0
set @ccfromdate = '01.04.2007'
*/
--
	set @dropped = 0

	--       
	declare @a table ( IdRecDir int, ALineNum nvarchar ( 20 ), BLineNum nvarchar ( 20 ), TimeStart DateTime, FromCC bit )
	declare @b table ( IdConf uniqueidentifier, IdRecDir int, Room int, TimeStart DateTime, IsRecorded bit )


	if ( @pbxdropfiles = 1 and @ccdropfiles = 1 )	
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where (( TimeStart < @pbxfromdate and FromCC = 0 )
				Or ( TimeStart < @ccfromdate and FromCC = 1 )) 
				And IsRecorded = 1
			Order By TimeStart

	else if ( @pbxdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where ( TimeStart < @pbxfromdate and FromCC = 0 )
				And IsRecorded = 1
			Order By TimeStart

	else if ( @ccdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1 --with ( TabLock, HoldLock )
			Where ( TimeStart < @ccfromdate and FromCC = 1 )
				And IsRecorded = 1
			Order By TimeStart

	
	--    .    PBX
	if ( @pbxdropfiles = 1 )
		Insert into @b
			Select Id, IdRecDir, Room, TimeStart, IsRecorded
			From A_Stat_Conference 
			Where ( TimeStart < @pbxfromdate )
				And IsRecorded = 1

	
	--   
	if ( @pbxdrop = 1 and @ccdrop = 1 ) begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )
			Or ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end

	else if ( @pbxdrop = 1 ) begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )

		Set @dropped = @@rowcount
	end

	else if ( @ccdrop = 1 ) begin
		Delete
		From A_Stat_Connections_1x1 --with ( TabLock )
		Where ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end


	--   .  PBX 
	if ( @pbxdrop = 1 ) begin
		Delete 
		From A_Stat_Conference
		Where ( TimeStart < @pbxfromdate )

		Set @dropped = @dropped + @@rowcount

		Delete
		From A_Stat_Conference_Competitors 
		Where not exists ( Select Id from A_Stat_Conference where A_Stat_Conference.Id = IdConf )
	end

	
	--  
	Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
	From @a

	 Union

	Select IdRecDir, cast ( Room as nvarchar(20) ), '', TimeStart, 0 
	From @b	
end
GO