-----------------------------------------------------------------
----------------120214_indexes-----------------
-----------------------------------------------------------------
---------------------------------------
--[dbo].[A_Stat_Conference_Competitors]
---------------------------------------

--  ,  
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference_Competitors]') AND name like N'PK__A_St%')
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_Stat_Conference_Competitors] DROP CONSTRAINT [' +
			(SELECT NAME FROM dbo.sysindexes 
			WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference_Competitors]') 
			AND name like N'PK__A_St%') + ']';
exec sp_executesql @comm
end
GO

--  
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference_Competitors]') AND name = N'idx_StatConnfComp_TStart_clstd')
CREATE CLUSTERED INDEX [idx_StatConnfComp_TStart_clstd] ON [dbo].[A_Stat_Conference_Competitors] 
(
	[TimeStart] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

---------------------------
--[dbo].[A_Stat_Conference]
---------------------------

--  
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference]') AND name like N'%PK__A_St%')
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_Stat_Conference] DROP CONSTRAINT [' +
			(SELECT NAME FROM dbo.sysindexes 
			WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference]') AND name like N'%PK__A_St%') + ']';
exec sp_executesql @comm
end
GO
/****** Object:  Index [idx_StatConf_TStart_TStop]    Script Date: 12/12/2011 12:58:57 ******/
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference]') AND name = N'idx_StatConf_IDConf')
CREATE NONCLUSTERED INDEX [idx_StatConf_IDConf] ON [dbo].[A_Stat_Conference] 
(
	[ID] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO
--  
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Conference]') AND name = N'idx_StatConf_TStart_clstd')
CREATE CLUSTERED INDEX [idx_StatConf_TStart_clstd] ON [dbo].[A_Stat_Conference]
(
	[TimeStart] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

----------------------------
--[dbo].[A_Stat_MissedCalls]
----------------------------
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_MissedCalls]') AND name like N'PK__A_St%')
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_Stat_MissedCalls] DROP CONSTRAINT [' +
			(SELECT NAME FROM dbo.sysindexes 
			WHERE id = OBJECT_ID(N'[dbo].[A_Stat_MissedCalls]') AND name like N'PK__A_St%') + ']';
exec sp_executesql @comm
end
GO

--  
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_MissedCalls]') AND name = N'idx_StatMissedCalls_TStart_clstd')
CREATE CLUSTERED INDEX [idx_StatMissedCalls_TStart_clstd] ON [dbo].[A_Stat_MissedCalls] 
(
	[TimeStart] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

-----------------------------------------------------------------
-------------120215_W_Stat_MyCalls_Get------------------------
-----------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_MyCalls_Get]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_MyCalls_Get]
GO

create procedure [dbo].[W_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 10 - , 11 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@iduser 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	@first int= NULL,
	@count int= NULL
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - , 2 - , 3 - , 0 - 
--declare @type 	int --1 - , 2 - , 3 - , 0 - 
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @iduser uniqueidentifier, @comment 	nvarchar ( 4000 ),@showivr bit, @first int,@count int

--set dateformat ymd
--select @media = 0,@type = 0,
--	@iduser='1654740F-0600-493B-B8FD-B09AC9A5A99C',
--	@dstart = '2012-01-30 15:16',@dstop = '2012-01-30 17:26',
--	@number = '', 
--	@comment = '', @showivr=0,@first = 0,@count = 140

 create   table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					TimeAnswer DateTime, 
					TimeStop DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					IsRecorded int, 
					IdRecDir int, 
					ALineNum nvarchar ( 10 ) collate database_default, 
					BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier, 
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 100 ) collate database_default, 
					IsConf int, Director uniqueidentifier, 
					CTS DateTime
			
)

     
declare @filtercomment bit
set @filtercomment =  0 

Declare @id0 uniqueidentifier
Set @id0 = '00000000-0000-0000-0000-000000000000'

    -------------------------------------
    --  -----------------------
    -------------------------------------

Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )
Select sc.Id, 
		sc.IdChain,
		null, 
		0, 
		sc.TimeStart, 
		sc.TimeAnswer, 
		sc.TimeStop, 
		sc.TimeStop - sc.TimeAnswer as Length, 
		'', 
		'', 
		IsRecorded, 
		IdRecDir, 
		ALineNum, 
		BLineNum, --ARecFile, BRecFile, 
		AUserId, 
		BUserId, 
		ALineId, 
		BLineId, 
		AOutNumber, 
		BOutNumber, 
		AStr, 
		BStr,
		0 as IsConf, 
		@id0 as Director, 
		sc.TimeStart as CTS
From A_Stat_Connections_1x1 sc --with ( TabLock )
Where sc.TimeStop is not null and
			TimeStart >= @dstart 
			and TimeStart < @dstop
			and (AUserId = @iduser  or  BUserId = @iduser)
			and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
--Order By TimeStart Desc

	-------------------------------------
    --  ----------------------
    -------------------------------------
Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, TimeAnswer, TimeStop, Length,
			Number, AbonentName, IsRecorded, IdRecDir, 
			ALineNum, BLineNum,
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr, 
			IsConf, Director, CTS )

Select Idg, IdChain, 3, 3, 
TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
AOutNumber, AStr, 0, 0, 
ALineNum, BLineNum, 
AUserId, BUserId,
ALineId, BLineId,
AOutNumber, Number,
AStr, '',
0, @id0, TimeStart
From A_Stat_MissedCalls
Where ( BUserId = @iduser )
And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))

    -------------------------------------
    --  ----------------------
    -------------------------------------
   
    Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		    Select IdConn, 
			IdChain, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end,
			scc.TimeStart, 
			scc.TimeStart as TimeAnswer, 
			scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			 0,--case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, 
			LineNum, 
			sc.Room, 
			scc.IdUser, 
			@idconfuser,
			scc.IdLine, 
			IdConf,
			'', 
			'', 
			StrName, 
			case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, 
			Director, 
			sc.TimeStart as CTS
			
		FROM A_Stat_Conference_Competitors scc	
			Inner join A_Stat_Conference sc with (index (idx_StatConf_IDConf))
			on sc.Id = scc.IdConf
			--Left join @A_Stat_Conference_tmp2 sct 
			--on sc.Id = sct.Id --    
		
		where  scc.TimeStart between @dstart and @dstop 
			and scc.IdUser = @iduser
 
	-----------------------------------
  	--  -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @iduser
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @iduser
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @iduser and o.BUserId = u.Id ) or ( o.BUserId = @iduser and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @iduser )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @id0 )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From #output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	--  ---------------------------
	-----------------------------------
	--select  isnull(max (rownumber),0) 
	--from #output
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
(
	TimeStart deSC
)WITH FILLFACTOR = 100 ON [PRIMARY]

     --  
     
	Select			rownumber = identity(int,1,1),
					sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart, 
					--TimeAnswer, 
					--TimeStop, 
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					--ALineId, 
					--BLineId, 
					--ALineNum, 
					--BLineNum, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName, 
					IsRecorded, 
					IdRecDir, 
					IsConf, 
					Director, 
					CTS, 
					case When ( c.Id is null ) then 0 else 1 end as HasComment	
					into #out	
	From #output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where (( Media = @media ) or ( @media = 0 ) or ( Type >= 10 ))
	Order By TimeStart Desc
	select * from #out
	where rownumber between @first and @first + @count-1	
drop table #out
drop table #output
end
GO

-----------------------------------------------------------------
------------120216_indexes----------------------------
-----------------------------------------------------------------

--exec sp_spaceused 'A_stat_connections_1x1'
/****** Object:  Index [idxTimeStartTimeStop]    Script Date: 12/20/2011 14:51:00 ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Connections_1x1]') AND name = N'idxTimeStartTimeStop')
DROP INDEX [dbo].[A_Stat_Connections_1x1].[idxTimeStartTimeStop]
GO

/****** Object:  Index [idx_StatConn_CoverSel]    Script Date: 12/20/2011 15:40:42 ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Connections_1x1]') AND name = N'idx_StatConn_CoverSel')
DROP INDEX [dbo].[A_Stat_Connections_1x1].[idx_StatConn_CoverSel]
GO

/****** Object:  Index [idx_StatConn_AOutNumber_BUserId]    Script Date: 12/22/2011 09:23:28 ******/
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Connections_1x1]') AND name = N'idx_StatConn_AOutNumber_BUserId')
CREATE NONCLUSTERED INDEX [idx_StatConn_AOutNumber_BUserId] ON [dbo].[A_Stat_Connections_1x1] 
(
	[AOutNumber] ASC,
	[BUserId] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

/****** Object:  Index [idx_StatConn_AUserId_BUserId]    Script Date: 12/22/2011 09:23:31 ******/
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Connections_1x1]') AND name = N'idx_StatConn_AUserId_BUserId')
CREATE NONCLUSTERED INDEX [idx_StatConn_AUserId_BUserId] ON [dbo].[A_Stat_Connections_1x1] 
(
	[AUserId] ASC,
	[BUserId] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

/****** Object:  Index [idx_StatConn_BOutNumber_AUserId]    Script Date: 12/22/2011 09:23:42 ******/
IF not EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Connections_1x1]') AND name = N'idx_StatConn_BOutNumber_AUserId')
CREATE NONCLUSTERED INDEX [idx_StatConn_BOutNumber_AUserId] ON [dbo].[A_Stat_Connections_1x1] 
(
	[BOutNumber] ASC,
	[AUserId] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO

-----------------------------------------------------------------
-----------120217_W_Stat_MyCalls_Relative--------------------------
-----------------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_MyCalls_Relative]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_MyCalls_Relative]
GO

create procedure [dbo].[W_Stat_MyCalls_Relative]
	@userid 	uniqueidentifier,
	@abonent uniqueidentifier ,
	@number 	nvarchar ( 50 )
as
begin

--dbcc freeproccache
--dbcc dropcleanbuffers

--declare @media 	int --1 - , 2 - , 3 - , 0 - 
--declare @type 	int --1 - , 2 - , 3 - , 0 - 
--declare @dstart datetime
--declare @dstop 	datetime
--declare @number nvarchar ( 50 )
--declare @userid uniqueidentifier,  @abonent uniqueidentifier 

--set dateformat ymd
--set @media = 0
--set @type = 0
--set @dstart = '2011-11-01'
--set @dstop = '2011-12-06'
--set @number = ''
--select @userid = '7a6c312a-0028-4007-beee-e73f93f9cb96'	, 
--	@abonent = 'CE293C6A-E748-45D9-8DC1-ED1E34B759FC'

 create   table #output( 
					Id uniqueidentifier, 
					IdChain uniqueidentifier, 
					Media int, 
					Type int, 
					TimeStart DateTime, 
					Length DateTime, 
					Number nvarchar ( 50 ) collate database_default, 
					AbonentName nvarchar ( 200 ) collate database_default, 
					AUserId uniqueidentifier, 
					BUserId uniqueidentifier, 
					ALineId uniqueidentifier, 
					BLineId uniqueidentifier,
					AOutNumber nvarchar ( 50 ) collate database_default, 
					BOutNumber nvarchar ( 50 ) collate database_default, 
					AStr nvarchar ( 200 ) collate database_default, 
					BStr nvarchar ( 100 ) collate database_default
)
     
declare @filtercomment bit
set @filtercomment =  0 

    -----------------------------------------------------------
    ------------------------  -----------------------
    -----------------------------------------------------------
if (@number ='')
begin
   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId, 
			ALineId, BLineId,
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc 
	Where (AUserId = @userid  and  BUserId = @abonent)
	order by timestart desc 

   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId,
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc --with ( TabLock )
	Where (AUserId = @abonent  and  BUserId = @userid)
	--and TimeStop is not null
	order by timestart desc 
	
end
	
else
	begin
   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId,
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select  top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId, 
			ALineId, BLineId,
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc 
	Where (Boutnumber = @number and AUserId = @userid)
	order by timestart desc 

   	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr) 
   	Select top 30 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', 
			AUserId, BUserId,
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr
	From A_Stat_Connections_1x1 sc --with ( TabLock )
	Where (Aoutnumber = @number  and  BUserId = @userid)
	--and TimeStop is not null
	order by timestart desc 
end


	-------------------------------------
    --  ----------------------
    -------------------------------------
if (@number ='')
begin
	Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
	Select top 30 Idg, IdChain, 2, 0, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where (AUserId = @userid  and  BUserId = @abonent) 
	order by timestart desc 
	
		Insert into #output ( Id, IdChain, Media, Type,
				TimeStart, Length,
				Number, AbonentName, 
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber)
	Select top 30 Idg, IdChain, 3, 3, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where (AUserId = @abonent  and  BUserId = @userid)
	order by timestart desc 
	
	--select * from #output
	
end
else
begin
	Insert into #output ( Id, IdChain, Media, Type,
			TimeStart, Length,
			Number, AbonentName, 
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber)

	Select top 30 Idg, IdChain, 3, 3, 
	TimeStart, TimeStop - TimeStart, 
	AOutNumber, AStr,
	AUserId, BUserId,
	ALineId, BLineId,
	AOutNumber, Number
	From A_Stat_MissedCalls
	where ( BUserId = @userid ) and ( AOutNumber = @number )
	order by timestart desc 
end

--	-----------------------------------
--  	--  -----------------
--	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From #output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From #output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From #output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From #output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From #output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @userid )

	Update o
	Set o.AbonentName = c.Name
	From #output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = '00000000-0000-0000-0000-000000000000' )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From #output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From #output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	--  ---------------------------
	-----------------------------------
	
	CREATE CLUSTERED INDEX [idx_TStart_clstd] ON #output
(
	TimeStart deSC
)WITH FILLFACTOR = 100 ON [PRIMARY]

     --  
     
	Select	top 30	sc.Id, 
					IdChain, 
					Media, 
					Type, 
					TimeStart,  
					Cast ( Cast ( Length as float ) * 86400 as int ) as Length, 
					Number, 
					Abonent = case When sc.Type = 1 Then sc.AUserid else sc.BUserid end,
					AbonentName	
	From #output sc
	Order By TimeStart Desc

drop table #output
end

GO

-----------------------------------------------------------------
-----------------120218_W_Stat_ByInterval ( idchain)---------------------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_ByInterval]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_ByInterval]
GO

Create procedure [dbo].[W_Stat_ByInterval]
	@dstart 	datetime,
	@dstop 		datetime,
	@interval	int, --(15,30,60,180) (1) (7) (12)
	@type		int --(-1) (1) (2) (3) (4) (5)
	
as
begin

--exec [dbo].[W_Stat_ByInterval] 
--	@dstart = '2012-01-20 11:06', 
--	@dstop = '2012-01-30 11:26',
--	@interval = 60,
--	@type = -1

-------------------------------------------------
----  ( idchain) +  ---
-------------------------------------------------

------
--declare @dstart  datetime, @dstop datetime, @interval int, @type int
--select @dstart  = '2012-01-20 11:06', @dstop = '2012-01-30 17:26'

--select @interval = 12 --(15,30,60,180) (1) (7) (12)
--		,@type = -1 -- (1) (2) (3) (4) (5)
-------

declare @mnog float		
select @mnog = case @interval
	when 15 then 95.999999999999
	when 30 then 47.999999999999
	when 60 then 23.999999999999
	when 180 then 7.999999999999
	else 23.999999999999
	end
if (@interval is null) or (@interval not in (15,30,60,180,1,7,12,17))
	set @interval = 60

SELECT [Id]
      ,[IdChain]
      ,[IdPrev]
      ,[IdNext]
	  ,[timeint] =	null
	  ,[dateint] =	case when @interval in (17) then null
					when @interval = 12 then cast(floor(cast(timestart as float))-(DatePart(d, timestart))+1 as datetime)	
					when @interval = 7 then cast(floor(cast(timestart as float))-(DatePart(dw, timestart)+5)%7 as datetime)
					when @interval = 1 then cast(floor(cast(timestart as float))as datetime)	
					when @interval in (15,30,60,180) then cast( 
								( floor( cast(timestart as float)*@mnog)/@mnog )
									as datetime)
					else null						
					end
      ,[TimeStart]
      ,[TimeAnswer]
      ,[TimeStop]
      ,[ReasonStart]
      ,[ReasonStop]
      ,[AOutNumber]
      ,[BUserId]
      ,[ConnectionType]
		,[type] = case 
						when [ConnectionType] in (4,5) then 3
						when [ConnectionType] in (1,6,7) then 2
						when [ConnectionType] in (2,3,8) then 1
						else 0
					end		
		,[suc] = 0	
		,[unsuc] = 0
		,[wait] = 0 
		,[ring] = 0
		,[talk] = datediff (ss,[TimeAnswer],[TimeStop])
		,[hold] = 0
into #temp1
FROM [A_Stat_Connections_1x1]
where timestart between @dstart  and @dstop
and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)

insert into #temp1
select [Id] 
      ,[IdChain] = [Id] 
      ,[IdPrev] = null
      ,[IdNext] =null
	  ,[timeint] =	null
	  ,[dateint] =	case when @interval in (17) then null
					when @interval = 12 then cast(floor(cast(timestart as float))-(DatePart(d, timestart))+1 as datetime)	
					when @interval = 7 then cast(floor(cast(timestart as float))-(DatePart(dw, timestart)+5)%7 as datetime)
					when @interval = 1 then cast(floor(cast(timestart as float))as datetime)	
					when @interval in (15,30,60,180) then cast( 
								( floor( cast(timestart as float)*@mnog)/@mnog )
									as datetime)
					else null
					end
      ,[TimeStart]
      ,[TimeAnswer] = null
      ,[TimeStop]
      ,[ReasonStart] = null
      ,[ReasonStop] = null
      ,[AOutNumber] = null
      ,[BUserId] = null
      ,[ConnectionType] = null
		,[type] = 5	
		,[suc] = 0
		,[unsuc] = 0
		,[wait] = 0
		,[ring] = 0
		,[talk] = datediff (ss,[TimeStart],[TimeStop])
		,[hold] = 0
from [A_Stat_Conference]
where timestart between @dstart and @dstop

select [idchain]
		,[datetimestart] = min (timestart)
		,[dateint] = min (dateint)
		,[timeint] = min (timeint)
		,[type] = max ([type])
		,[count] = count(cast(id as nvarchar (50)))
		,[suc] = isnull(sum (suc),1) 
		,[unsuc] = sum (unsuc)
		,[wait] = sum (wait)
		,[ring] = sum (ring) 
		,[talk] = sum (talk)
		,[hold] = sum (hold)
into #temp2
from #temp1
group by idchain

select [type]
	,[count] = count (*) 
	--,[waitavg] = avg (wait)
	--,[waitmax] = max (wait)
	,[talkavg] = avg (talk)
	--,[talkmax] = max (talk)
from #temp2
group by [type]

if @interval in (15,30,60,180)
begin
	select dateint [int]
	,[count] 
	,[talkavg]
	from (
		select dateint
		,[count] = count (*)
		,[talkavg] = avg (talk)
		from #temp2
		where @type = -1 or [type] = @type
		group by dateint
	) t1
	order by dateint
end
else if @interval = 1
begin 
	select dateint [int]
	,[count] 
	,[talkavg]
	from (
		select dateint
		,[count] = count (*)
		,[talkavg] = avg (talk)
		from #temp2
		where @type = -1 or [type] = @type
		group by dateint
	) t1
	order by dateint
end
else if @interval = 7
begin 
	select [int]
	,[count] 
	,[talkavg]
	from (
		select [dateint] [int]
		,[count] = count (*)
		,[talkavg] = avg (talk)
		from #temp2
		where @type = -1 or [type] = @type
		group by [dateint]
	) t1
	order by [int]
end
else if @interval = 17
begin 
	select [int]
	,[count] 
	,[talkavg]
	from (
		select (DatePart(dw, dateTimeStart)+5)%7 [int]
		,[count] = count (*)
		,[talkavg] = avg (talk)
		from #temp2
		where @type = -1 or [type] = @type
		group by (DatePart(dw, dateTimeStart)+5)%7
	) t1
	order by [int]
end
else if @interval = 12
begin 
	select [int]
	,[count] 
	,[talkavg] 
	from (
		select [dateint] [int]
		,[count] = count (*)
		,[talkavg] = avg (talk)
		from #temp2
		where @type = -1 or [type] = @type
		group by [dateint]
	) t1
	order by [int]
end

drop table #temp1
drop table #temp2

end
GO

-----------------------------------------------------------------
----------------120219_W_Stat_Departments ( )-----------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_Departments]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_Departments]
GO

Create procedure [dbo].[W_Stat_Departments]
	@dstart 	datetime,
	@dstop 		datetime,
	@type		int --(-1) (1) (2) (3) (4) (5)
as
begin

	--exec [dbo].[W_Stat_Departments] 
	--	@dstart  = '2012-01-20 11:06', 
	--	@dstop = '2012-01-30 11:26', 
	--	@type = -1--(-1) (1) (2) (3) (4) (5)
	-----------------------------------------------
	------   --------
	-----------------------------------------------

	--declare @dstart  datetime, @dstop datetime, @type int --(-1) (1) (2) (3) (4) (5)
	--select @dstart  = '2012-01-20 11:26', @dstop = '2012-01-30 17:26', @type = 5
	
	
	SELECT top 0 [Id] [group]
		  ,[Id] [Id]
		  ,[IdChain]	
		  ,[TimeStart]
		  ,[TimeAnswer]
		  ,[TimeStop]
		  ,[ReasonStart]
		  ,[ReasonStop]
		  ,[StopSide]
		  ,[AOutNumber]
		  ,[AUserId]
		  ,[BUserId]
		  ,[ConnectionType]
  		  ,[type] = 0
	into #temp1
	FROM [oktell].[dbo].[A_Stat_Connections_1x1]
	
	if (@type in (-1,1,2,3))
	begin
		insert into #temp1
		SELECT isnull(u1.parentgroupid, 'AB000000-0000-0000-0000-000000000000')[group]
			,x1.[Id]
			  ,[IdChain]
			  --,[IdPrev]
			  --,[IdNext]	
			  ,[TimeStart]
			  ,[TimeAnswer]
			  ,[TimeStop]
			  ,[ReasonStart]
			  ,[ReasonStop]
			  ,[StopSide]
			  ,[AOutNumber]
			  ,[AUserId]
			  ,[BUserId]
			  ,[ConnectionType]
  			  ,[type] = case 
							when [ConnectionType] in (4,5) then 3	--
							when [ConnectionType] in (1,6,7) then 2	--
							when [ConnectionType] in (2,3,8) then 1	--
							else 0
						end	
		FROM [oktell].[dbo].[A_Stat_Connections_1x1] x1
		left join a_users u1
		on x1.auserid = u1.id
		where timestart between  @dstart  and @dstop
		and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)
		union 
		SELECT isnull(u2.parentgroupid, 'AB000000-0000-0000-0000-000000000000')[group]
			,x1.[Id]
			  ,[IdChain]
			  --,[IdPrev]
			  --,[IdNext]	
			  ,[TimeStart]
			  ,[TimeAnswer]
			  ,[TimeStop]
			  ,[ReasonStart]
			  ,[ReasonStop]
			  ,[StopSide]
			  ,[AOutNumber]
			  ,[AUserId]
			  ,[BUserId]
			  ,[ConnectionType]
  			  ,[type] = case 
							when [ConnectionType] in (4,5) then 3	--
							when [ConnectionType] in (1,6,7) then 2	--
							when [ConnectionType] in (2,3,8) then 1	--
							else 0
						end	
		FROM [oktell].[dbo].[A_Stat_Connections_1x1] x1
		left join a_users u2
		on x1.buserid = u2.id
		where timestart between  @dstart  and @dstop
		and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)
	end

	if (@type in (-1,5))
	begin
		insert into #temp1
		SELECT isnull(u1.parentgroupid, 'AB000000-0000-0000-0000-000000000000')[group]
			  ,[Id]=[IdConf]
			  ,[IdConf]
			  ,[TimeStart] = null
			  ,[TimeAnswer] = min([TimeStart])
			  ,max([TimeStop])
			  ,[ReasonStart] = null
			  ,[ReasonStop] = null
			  ,[StopSide] = null
			  ,[AOutNumber] = null
			  ,[AUserId] = null--[IdUser]
			  ,[BUserId] = null
			  ,[ConnectionType] = null
			  ,[type] = 5
		FROM [oktell].[dbo].[A_Stat_Conference_Competitors]
			left join a_users u1
		on iduser = u1.id
  		where timestart between @dstart and @dstop
		group by [IdConf],u1.parentgroupid
	end

	--    
	--select [group]
	--	,[count] = count (*) 
	--	,[talkavg] = avg (datediff (ss,[TimeAnswer],[TimeStop]))
	--from #temp1	
	--where @type = -1 or [type] = @type
	--group by [group]

	select [group]
		,[people]
		,[count]
		,[talkavg]
	from
	(select [group]
			,[count] = count (*) 
			,[talkavg] = avg (datediff (ss,[TimeAnswer],[TimeStop]))
		from #temp1
		where @type = -1 or [type] = @type
		group by [group]) t1
	left join 
	(select parentgroupid
	,count(*) [people]
	from A_users
	group by parentgroupid ) t2
	on t1.[group] = t2.parentgroupid
	where [group] != 'AB000000-0000-0000-0000-000000000000'
	
	drop table #temp1

end
GO

-----------------------------------------------------------------
-----------------120220_W_Stat_DepartmentSummary ( )-------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[W_Stat_DepartmentSummary]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_DepartmentSummary]
GO

Create procedure [dbo].[W_Stat_DepartmentSummary]
	@dstart 	datetime,
	@dstop 		datetime, 
	@idgroup	uniqueidentifier
as
begin

	--exec [dbo].[W_Stat_DepartmentSummary]
	--	@dstart = '2012-01-20 11:06', 
	--	@dstop = '2012-01-30 11:26',
	--	@idgroup = '4AB09B9D-21BB-483D-AC72-292B1FC71C1D'
	
	-----------------------------------------
	------   --------
	-----------------------------------------

	--declare @dstart datetime, @dstop datetime, @idgroup	uniqueidentifier
	--select @dstart = '2012-01-20 11:06', @dstop = '2012-01-30 17:26',@idgroup = '4AB09B9D-21BB-483D-AC72-292B1FC71C1D'

	select id 
	into #users
	from [dbo].[A_Users]
	where parentgroupid = @idgroup
	--insert into #users
	--values  ('AB000000-0000-0000-0000-000000000000')

	SELECT [Id]
		  ,[IdChain]
		  ,[TimeStart]
		  ,[TimeAnswer]
		  ,[TimeStop]
		  ,[ReasonStart]
		  ,[ReasonStop]
		  ,[StopSide]
		  ,[AOutNumber]
		  ,[AUserId]
		  ,[BUserId]
		  ,[ConnectionType]
  			,[type] = case 
						when [ConnectionType] in (4,5) then 3	--
						when [ConnectionType] in (1,6,7) then 2	--
						when [ConnectionType] in (2,3,8) then 1	--
						else 0
					end	
	into #temp1
	FROM [oktell].[dbo].[A_Stat_Connections_1x1]
	where timestart between @dstart and @dstop
	and ([AUserId] in (select * from #users) or [BUserId] in (select * from #users))
	and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)

	insert into #temp1
	SELECT [Id]=[IdConf]
		  ,[IdConf]
		  ,[TimeStart] = null
		  ,[TimeAnswer] = min([TimeStart])
		  ,max([TimeStop])
		  ,[ReasonStart] = null
		  ,[ReasonStop] = null
		  ,[StopSide] = null
		  ,[AOutNumber] = null
		  ,[AUserId] = null--[IdUser]
		  ,[BUserId] = null
		  ,[ConnectionType] = null
		  ,[type] = 5
	FROM [oktell].[dbo].[A_Stat_Conference_Competitors]
  	where timestart between @dstart and @dstop
	and [IdUser] in (select * from #users)
	group by [IdConf]
  
	select [type]
		,[count] = count (*) 
		,[talkavg] = avg (datediff(ss,[TimeAnswer],[TimeStop]))
	from #temp1
	group by [type]

	drop table #temp1
	drop table #users

end
GO

-----------------------------------------------------------------
-----------------120221_W_Stat_Users ( )----
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_Users]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_Users]
GO

Create procedure [dbo].[W_Stat_Users]
	@dstart 	datetime,
	@dstop 		datetime,
	@type		int --(-1) (1) (2) (3) (4) (5)
as
begin

	--exec [dbo].[W_Stat_Users] 
	--	@dstart  = '2012-01-20 11:06', 
	--	@dstop = '2012-01-30 11:26', 
	--	@type = -1 --(-1) (1) (2) (3) (4) (5)
	-----------------------------------------------
	------    --------
	-----------------------------------------------

	--declare @dstart  datetime, @dstop datetime, 	@type int --(-1) (1) (2) (3) (4) (5)
	--select @dstart  = '2012-01-20 11:06', @dstop = '2012-01-30 17:26', @type = -1
	
	SELECT 	[IdUser] = [AUserId]
		  ,[Id]
		  ,[IdChain]
		  --,[IdPrev]
		  --,[IdNext]	
		  ,[TimeStart]
		  ,[TimeAnswer]
		  ,[TimeStop]
		  ,[ReasonStart]
		  ,[ReasonStop]
		  ,[StopSide]
		  ,[AOutNumber]
		  ,[ConnectionType]
  		  ,[type] = case 
						when [ConnectionType] in (4,5) then 3	--
						when [ConnectionType] in (1,6,7) then 2	--
						when [ConnectionType] in (2,3,8) then 1	--
						else 0
					end	
	into #temp1
	FROM [oktell].[dbo].[A_Stat_Connections_1x1] x1
	where timestart between  @dstart  and @dstop
	and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)
	union 
	SELECT [IdUser] = [BUserId]
		,[Id]
		  ,[IdChain]
		  --,[IdPrev]
		  --,[IdNext]	
		  ,[TimeStart]
		  ,[TimeAnswer]
		  ,[TimeStop]
		  ,[ReasonStart]
		  ,[ReasonStop]
		  ,[StopSide]
		  ,[AOutNumber]
		  ,[ConnectionType]
  		  ,[type] = case 
						when [ConnectionType] in (4,5) then 3	--
						when [ConnectionType] in (1,6,7) then 2	--
						when [ConnectionType] in (2,3,8) then 1	--
						else 0
					end	
	FROM [oktell].[dbo].[A_Stat_Connections_1x1] x1
	where timestart between  @dstart  and @dstop
	and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)
	
	insert into #temp1
	SELECT [IdUser]
		  ,[Id]=[IdConn]
		  ,[IdConf]
		  ,[TimeStart] = [TimeStart]
		  ,[TimeAnswer] = [TimeStart]
		  ,[TimeStop]
		  ,[ReasonStart] = null
		  ,[ReasonStop] = null
		  ,[StopSide] = null
		  ,[AOutNumber] = null
		  ,[ConnectionType] = null
		  ,[type] = 5
	FROM [oktell].[dbo].[A_Stat_Conference_Competitors]
  	where timestart between @dstart and @dstop
	
	select [IdUser]
		,[count] = count (*) 
		,[talkavg] = avg (datediff (ss,[TimeAnswer],[TimeStop]))
	from #temp1	
	where @type = -1 or [type] = @type
	group by [IdUser]
	
	drop table #temp1

end
GO

-----------------------------------------------------------------
----------------120222_W_Stat_UserSummary ( )-----
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[W_Stat_UserSummary]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_UserSummary]
GO

Create procedure [dbo].[W_Stat_UserSummary]
	@dstart 	datetime,
	@dstop 		datetime, 
	@iduser	uniqueidentifier
as
begin

	--exec [dbo].[W_Stat_UserSummary]
	--	@dstart = '2012-01-20 11:06', 
	--	@dstop = '2012-01-30 11:26',
	--	@iduser = '1654740F-0600-493B-B8FD-B09AC9A5A99C'
	
	-----------------------------------------
	------    --------
	-----------------------------------------

	--declare @dstart datetime, @dstop datetime, @iduser	uniqueidentifier
	--select @dstart = '2012-01-20 11:06', @dstop = '2012-02-20 17:26',@iduser = '33C2050A-712B-4037-805B-728A18AD1B98'

	SELECT [Id]
		  ,[IdChain]
		  ,[TimeStart]
		  ,[TimeAnswer]
		  ,[TimeStop]
		  ,[ReasonStart]
		  ,[ReasonStop]
		  ,[StopSide]
		  ,[AOutNumber]
		  ,[AUserId]
		  ,[BUserId]
		  ,[ConnectionType]
  			,[type] = case 
						when [ConnectionType] in (4,5) then 3	--
						when [ConnectionType] in (1,6,7) then 2	--
						when [ConnectionType] in (2,3,8) then 1	--
						else 0
					end	
	into #temp1
	FROM [oktell].[dbo].[A_Stat_Connections_1x1]
	where timestart between @dstart and @dstop
	and ([AUserId] = @iduser or [BUserId] = @iduser)
	and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= 0.0000115740767796524)

	--select * from #temp1
	
	insert into #temp1
	SELECT [Id]=[IdConf]
		  ,[IdConf]
		  ,[TimeStart] = null
		  ,[TimeAnswer] = min([TimeStart])
		  ,max([TimeStop])
		  ,[ReasonStart] = null
		  ,[ReasonStop] = null
		  ,[StopSide] = null
		  ,[AOutNumber] = null
		  ,[AUserId] = null--[IdUser]
		  ,[BUserId] = null
		  ,[ConnectionType] = null
		  ,[type] = 5
	FROM [oktell].[dbo].[A_Stat_Conference_Competitors]
  	where timestart between @dstart and @dstop
	and [IdUser] = @iduser
	group by [IdConf]
	
  	--select * from #temp1
  
	select [type]
		,[count] = count (*) 
		,[talkavg] = avg (datediff(ss,[TimeAnswer],[TimeStop]))
	from #temp1
	group by [type]

	drop table #temp1

end
GO

-----------------------------------------------------------------
-----------------120223_W_Stat_FillTempByFilter------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_FillTempByFilter]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_FillTempByFilter]
GO

create Procedure [dbo].[W_Stat_FillTempByFilter]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	--@tstart datetime,
	--@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@idoperator uniqueidentifier , --Operator defined
	@idgroup uniqueidentifier = NULL,
	@idclient uniqueidentifier = NULL,
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	@type int = -1,--3- 2- 1-
	@showconf bit = 0,
	@comment nvarchar ( 4000 ) = NULL
as
begin
-- ,     ,            13.02.12

	--declare @iduser uniqueidentifier,
	--	@dstart datetime,
	--	@dstop datetime,
	--	@tstart datetime,
	--	@tstop datetime,
	--	@lentime datetime,
	--	@taskid uniqueidentifier, --Task defined
	--	@fromcc bit,
	--	@idoperator uniqueidentifier, --Operator defined
	--	@idgroup uniqueidentifier, --Operator defined	
	--	@idclient uniqueidentifier, 
	--	@innerprefix nvarchar(100), --Internal Number defined
	--	@outnumber nvarchar(100),  --Out Number defined
	--	@type int,--3- 2- 1-
	--	 @showconf bit,
	--	@comment nvarchar ( 4000 )	
	--select
	--@iduser='1654740F-0600-493B-B8FD-B09AC9A5A99C',
	--@dstart = '2012-01-30 15:16',@dstop = '2012-01-30 17:26',
	--@lentime='2006-07-26 00:00:01',@fromcc=0,@showconf  = 1,
	--@type=-1,@comment=N'', @idclient = 'B4E9C018-806E-43AE-80E9-A65B4C5B7B43' --, @idgroup = '4AB09B9D-21BB-483D-AC72-292B1FC71C1D'

		--@iduser,
		--@dstart,
		--@dstop,
		--@lentime,
		--@taskid,
		--@fromcc,
		--@operatorid,
		--@innerprefix,
		--@outnumber,
		--@type,
		--1, -- show conference,
		--@comment

		--  
	declare @filtercomment bit
	set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end


	--Prepare @A_Stat_Connections_1x1_tmp
	Declare @A_Stat_Connections_1x1_tmp1 table( Id uniqueidentifier PRIMARY KEY) 
	Declare @A_Stat_Connections_1x1_tmp table( Id uniqueidentifier PRIMARY KEY, AUSerId uniqueidentifier, BUSerId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier) 
	--Declare @tstartfloat float  declare @tstopfloat float 
	--set @tstartfloat = Convert ( float, @tstart )  
	--set @tstopfloat  = Convert ( float, @tstop )  
	--set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )  
	--set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )  
	--if ( @tstopfloat <= @tstartfloat )
	--    set @tstopfloat = @tstopfloat + 1

	declare @lt float
	set @lt = Convert ( float, @lentime ) - Floor ( Convert ( float, @lentime ) )


	-- Date & Time Intervals
	--     ,            13.02.12
	Insert into @A_Stat_Connections_1x1_tmp 
	select Id, AUSerId , BUSerId , ALineId , BLineId 
	from A_Stat_Connections_1x1 --With ( TabLock )
	where idchain in (
	select distinct idchain
	from A_Stat_Connections_1x1 sc
	where
		 ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
		--and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
		--and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
		and ( Convert ( float, TimeStop ) - Convert ( float, TimeAnswer ) >= @lt )
		and (( FromCC is null ) or ( FromCC <= @fromcc ))
		and (@type = -1 or (@type = 3 and ConnectionType in (4,5)) or (@type = 2 and ConnectionType in (1,6,7)) or (@type = 1 and ConnectionType in (2,3,8)))
	)
		--and not exists(select id from  @A_Stat_Connections_1x1_tmp where id=sc.ID)


	--Permissions
	--Users
	declare @upermitted table ( Id uniqueidentifier Primary Key )
	Insert into @upermitted
		Select UserB
		From A_UserControls auc
		Where UserA = @iduser

	if not exists (select UserB from  A_UserControls where UserA = @iduser and UserB = @iduser)
		Insert into @upermitted (Id) Values (@iduser)

	Declare @commpermitted table ( Id uniqueidentifier PRIMARY KEY)  	 -- Id Connection
	Insert into @commpermitted
		Select  sc.ID --auc.UserB   	
		From @upermitted up
			inner join @A_Stat_Connections_1x1_tmp sc on up.Id = sc.AUserId
	
	Insert into @commpermitted
		Select  sc.ID --auc.UserB   	
		From @upermitted up
			inner join @A_Stat_Connections_1x1_tmp sc on up.Id=sc.BUserId
		Where not exists(select id from @commpermitted where Id=sc.ID)


	--Lines
	print '------Lines'
	declare @lpermitted table ( Id uniqueidentifier Primary Key )
	Insert into @lpermitted
    	 Select IdLine
    	 From A_UserControlLines
    	 Where UserA = @iduser
          and IdLine != '11111111-1111-1111-1111-111111111111'       

	declare @canlistenext int       
	Select @canlistenext = Count ( * ) 
	From A_UserControlLines 
	Where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
    		Insert into @lpermitted
	          Select Id 
        	  From A_ServerExtLines sel
	          Where not exists(select id from @lpermitted where Id = sel.ID)
     
	Insert into @commpermitted
    	 Select sc.ID            
    	 From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on sc.ALineId=l.Id
    	 Where not exists(select id from @commpermitted where Id = sc.ID)

	Insert into @commpermitted            
    	 Select sc.ID            
    	 From @lpermitted l
          inner join @A_Stat_Connections_1x1_tmp sc on  sc.BLineId=l.Id
    	 Where not exists(select id from @commpermitted where Id = sc.ID)

	print '------Lines'

	delete @A_Stat_Connections_1x1_tmp 
	where id not in (select Id from @commpermitted )

--Numbers 
	--Inner
	if @innerprefix is not null 
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )

		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner join A_NumberPlanAction na on na.NumId = np.Id
				Inner join A_Rules r on na.ExtraId = r.Id
				Inner join A_RuleRecords rr on rr.RuleId = r.Id

		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1

			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid

			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid 
				From @temp

			/* */
			Delete From @temp	
		end --\MakePrefixTableAnyWay condition

		

		--Users
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.AUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BUserID=t.reactid
		where addrtype = 0 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		--Lines
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.ALineId=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
			inner join @t t on sc.BLineId=t.reactid
		where addrtype = 1 and prefix like @innerprefix
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)
		
		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
		
	end --\NUmbers

	--Outer NUMBVERS
	if @OutNumber is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  AOutNumber like '%'+@OutNumber+'%'

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  BOutNumber like '%'+@OutNumber+'%'
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

	end
	--\Outer NUMBVERS
	
	--CLients
	if @idclient is not null begin

	declare @clientcontacts table ( Id nvarchar (255) collate database_default Primary Key )
	insert into @clientcontacts 
	select content
	from A_ClientContacts
	where idclient = @idclient
		
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  exists (select * from @clientcontacts where id = AOutNumber) --     like

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from A_Stat_Connections_1x1 sc --With ( TabLock )
		where  exists (select * from @clientcontacts where id = BOutNumber) --     like
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1

	end
	--\--CLients

	--operatorid
	if @idoperator is not null begin

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where  AUserId=@idoperator

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  BUserId=@idoperator
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
	end

	--idgroup
	if @idgroup is not null begin

		declare @oppsingroup table ( Id uniqueidentifier Primary Key )
		insert into @oppsingroup 
		select id
		from A_Users
		where parentgroupid = @idgroup
		
		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id
		from @A_Stat_Connections_1x1_tmp sc
		where exists (select * from @oppsingroup where id = AUserId)

		Insert into @A_Stat_Connections_1x1_tmp1 
		select Id 
		from @A_Stat_Connections_1x1_tmp sc
		where  exists (select * from @oppsingroup where id = BUserId)
			and not exists(select id from  @A_Stat_Connections_1x1_tmp1 where id=sc.ID)

		delete @A_Stat_Connections_1x1_tmp 
			where id not in (select Id from @A_Stat_Connections_1x1_tmp1 )
		delete @A_Stat_Connections_1x1_tmp1
	end
	
	
	if ( @filtercomment > 0 ) begin

		Delete 
		From @A_Stat_Connections_1x1_tmp
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	end

	
	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'
	
	Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'


	-- 

	/*Declare @upermitted table ( Id uniqueidentifier )
	Insert into @upermitted 
		Select Id From A_USers
	
	Declare @dstart datetime
	Declare @dstop datetime
	Set @dstart = DateAdd ( d, -5, GetDate() )
	Set @dstop = GetDate()
*/
    if ( @showconf = 0 )
    begin

	Select sc.*
	FROM A_Stat_Connections_1x1 sc --With ( TabLock )--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		order by timestart
		--Inner Join @commpermitted cp on sc.ID=cp.ID

	--Select sc.*, 
	--	0 as IsConf, @idempty as Director, sc.TimeStart as CTS, 
	--	case When ( c.Id is null ) then 0 else 1 end as HasComment
	--FROM A_Stat_Connections_1x1 sc --With ( TabLock )--,@ulpermitted ul,@tasks t
		--Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		--Left join A_Stat_Comments c on sc.Id = c.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID
    end

    else

    begin

	--   	
	Declare @A_Stat_Conference_tmp1 table ( Id uniqueidentifier PRIMARY KEY, RecordAccess int, Director uniqueidentifier )

	--        ,      
	--        ,       
	Insert into @A_Stat_Conference_tmp1
		Select Id, RecordAccess, Director 
		From A_Stat_Conference sc
				Where ( TimeStart <= @dstop ) and ( TimeStop >= @dstart ) --       
			--and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
			--and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
			and ( Convert ( float, TimeStop ) - Convert ( float, TimeStart ) >= @lt )
		--Where ( TimeStart >= @dstart ) and ( TimeStart < @dstop ) 
		--	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )  
		--	and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) <= @tstopfloat ) 
		--	and ( Convert ( float, TimeStop ) - Convert ( float, TimeStart ) >= @lt )
		--Where ((( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
		--	or (( TimeStart < @dstop ) and ( TimeStop >= @dstop ))
		--	or (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
		--	or (( TimeStart >= @dstart ) and ( TimeStop <= @dstop )))

	--    ( )
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @A_Stat_Conference_tmp1
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end


	--   
	Declare @A_Stat_Conference_tmp2 table ( Id uniqueidentifier PRIMARY KEY )

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join @upermitted up on sc.Director = up.Id
		Where sc.RecordAccess = 1 --  

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
			Inner join @upermitted up on scc.IdUser = up.Id
		Where sc.RecordAccess = 2 -- 
		Group By sc.Id

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join A_Stat_Conference_RecordAccessUsers scr on sc.Id = scr.IdConf
			Inner join @upermitted up on scr.IdUser = up.Id
		Where sc.RecordAccess = 3 --  
		Group By sc.Id

	if ( @canlistenext > 0 ) 
	begin -- ,        , 
	    Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join A_Stat_Conference_Competitors scc on scc.IdConf = sc.Id
		Where scc.IdUser = 'BF000000-0000-0000-0000-000000000000'
			And not exists ( Select id from @A_Stat_Conference_tmp2 where id = sc.Id )
		Group By sc.Id
        end

        Select * From
        (
	    Select sc.*, 
		0 as IsConf, @idempty as Director, sc.TimeStart as CTS, 
		case When ( c.Id is null ) then 0 else 1 end as HasComment
 	    FROM A_Stat_Connections_1x1 sc --With ( TabLock )--,@ulpermitted ul,@tasks t
		Inner join @A_Stat_Connections_1x1_tmp sct on sc.Id=sct.Id
		Left join A_Stat_Comments c on sc.Id = c.Id
		--Inner Join @commpermitted cp on sc.ID=cp.ID

	    Union All

   	    --     ,        
	    --        
	    Select IdConn, sc.Id as IdChain, @idempty as IdPrev, @idempty as IdNext, 
		scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
		ReasonStart, ReasonStop, 0 as StopSide, 
		IdLine, IdConf, OutNumber, '', LineNum, SubString ( cast ( Room as nvarchar ( 10 ) ), 1, 10 ), 
		IdUser, @idconfuser, '', '', IsRecorded, case when sc.Type = 1 then 11/**/ else 10/**/ end, 
		StrName, SubString ( case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end, 1, 200 ), 
		0, 1, IdRecDir, 
		1 as IsConf, sc.Director, sc.TimeStart as CTS,
		case When ( c.Id is null ) then 0 else 1 end as HasComment
	    FROM A_Stat_Conference_Competitors scc
		Inner join A_Stat_Conference sc on sc.Id = scc.IdConf
		Inner join @A_Stat_Conference_tmp2 sct on sc.Id = sct.Id --  
		Left join A_Stat_Comments c on sc.Id = c.Id
		--Inner join @upermitted up on up.Id = scc.IdUser --             
	    Where ((( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
		or (( scc.TimeStart < @dstop ) and ( scc.TimeStop >= @dstop ))
		or (( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
		or (( scc.TimeStart >= @dstart ) and ( scc.TimeStop <= @dstop )))
		and (( @idoperator is null ) or ( scc.IdUser = @idoperator ))
		and (( @idgroup is null ) or ( exists (select * from @oppsingroup where id = scc.IdUser) ))
		and (( @idclient is null ) or ( exists (select * from @clientcontacts where id = scc.OutNumber) ))
		and (( @OutNumber is null ) or ( scc.OutNumber = @OutNumber ))
       )a
       order by timestart
    end
end
GO

-----------------------------------------------------------------
-----------------120224_W_Stat_GetJournal------------------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Stat_GetJournal]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Stat_GetJournal]
GO

Create procedure [dbo].[W_Stat_GetJournal]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@lentime datetime,
	@type int = -1,	
		
	@first int = 1, 
	@count int = 200,

	@idoperator uniqueidentifier = NULL, --Operator defined	
	@idclient uniqueidentifier = null,
	@idgroup uniqueidentifier = null,
	
	@showconference int = 1,	
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,

	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	
	@comment nvarchar ( 4000 ) = NULL

as
begin	

--exec W_Stat_GetJournal 
--@iduser='1654740F-0600-493B-B8FD-B09AC9A5A99C',
--@dstart = '2012-01-20 11:06',@dstop = '2012-01-30 17:26',
--@tstart='2006-07-26 00:00:00',@tstop='2006-07-26 23:59:59.997',
--@lentime='2006-07-26 00:00:01',@fromcc=0,
--@conntype=-1,@comment=N''

	--declare @iduser uniqueidentifier,
	--	@dstart datetime,
	--	@dstop datetime,
	--	@tstart datetime,
	--	@tstop datetime,
	--	@lentime datetime,
	--	@taskid uniqueidentifier, --Task defined
	--	@fromcc bit,
	--	@idoperator uniqueidentifier, --Operator defined
	--	@idgroup uniqueidentifier, 
	--	@idclient uniqueidentifier,
	--	@innerprefix nvarchar(100), --Internal Number defined
	--	@outnumber nvarchar(100),  --Out Number defined
	--	@type int,
	--	-- @showconference int = 1,
	--	@comment nvarchar ( 4000 ),
	--	@first int, 
	--	@count int
	--select	@iduser='1654740F-0600-493B-B8FD-B09AC9A5A99C',
	--		@dstart = '2012-01-30 15:16',@dstop = '2012-01-30 17:26',
	--		@lentime='2006-07-26 00:00:01',@fromcc=0,
	--		@type=-1,@comment=N'', @first = 1,@count = 50 

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'
	
	Select top 0 rownumber = identity(int,1,1),
		*, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #t 
	From A_Stat_Connections_1x1
	
	Insert into #t Exec W_Stat_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@lentime,
		@taskid,
		@fromcc,
		@idoperator,
		@idgroup, 
		@idclient,
		@innerprefix,
		@outnumber,
		@type,
		1, -- show conference,
		@comment

	Select t.*, 
		Cast ( Cast ( TimeStop - TimeAnswer as float ) * 86400 as int ) as Length, 
		Cast ( Cast ( TimeAnswer - TimeStart as float ) * 86400 as int ) as AnswerLength
	From #t t
	where rownumber between @first and @first + @count-1	
	--Order By TimeStart --Desc
	
	drop table #t
	
end
GO

-----------------------------------------------------------------
------------------120225_W_Users_GetNames--------------------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Users_GetNames]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Users_GetNames]
GO

Create Procedure [dbo].[W_Users_GetNames]
As
Begin
	Select Id, Name 
	From A_users
End
GO

-----------------------------------------------------------------
------------------120226_W_Clients_Autocomplete--------------------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Clients_Autocomplete]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].W_Clients_Autocomplete
GO

CREATE  procedure [dbo].W_Clients_Autocomplete
	@text	nvarchar ( 255 )
as
begin

	-- 
	--Select cl.id ,cl.[Name]
	--From A_Clients cl
	--where Name like '% ' + @text + '%' or Name like @text + '%'
	
	select top 20 * from
	(
	Select top 20 cl.id ,cl.[Name]
	From A_Clients cl
	where Name like @text + '%'
	union
	Select top 20 cl.id ,cl.[Name]
	From A_Clients cl
	where Name like '%[ "#@(-:;.,'']' + @text + '%'
	) t1
end
GO

-----------------------------------------------------------------
-----------------120227_W_UserNotifyLog----------------
-----------------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UserNotifyLog_GetUnshown]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_UserNotifyLog_GetUnshown]
GO

CREATE Procedure [dbo].[W_UserNotifyLog_GetUnshown]
	@iduser uniqueidentifier
as
begin
	Select top 500 [ID]
      ,[NotifyDateTime]
      ,[LogType]
      ,[TextSender]
      ,[TextInfo]
      ,[WasShown]
      ,[OneOnScreen]
      ,[OneOnScreenId] 
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )  
	and wasShown = 0
	and LogType = 262144
	order by NotifyDateTime desc
end
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UserNotifyLog_GetTypeList]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_UserNotifyLog_GetTypeList]
GO

create Procedure [dbo].[W_UserNotifyLog_GetTypeList]
	@iduser uniqueidentifier
as
begin
--select * from A_users
	Select distinct [TextSender]
	FROM A_User_NotifyLog 
where iduser = @iduser--'63843ac7-a9eb-4f95-8956-b2a7d66a292f'

end
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UserNotifyLog_GetNewCount]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_UserNotifyLog_GetNewCount]
GO

CREATE Procedure [dbo].[W_UserNotifyLog_GetNewCount]
	@iduser uniqueidentifier
	--,@dstart datetime,
	--@dstop datetime
as
begin
	Select count(*) [count]
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )  
	--and ( NotifyDateTime >= @dstart ) 
	--and ( NotifyDateTime < @dstop ) 
	and wasShown = 0
	and LogType = 262144
	--order by NotifyDateTime desc
end
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UserNotifyLog_GetByDate]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_UserNotifyLog_GetByDate]
GO

CREATE Procedure [dbo].[W_UserNotifyLog_GetByDate]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime
as
begin
	Select [ID]
      ,[NotifyDateTime]
      ,[LogType]
      ,[TextSender]
      ,[TextInfo]
      ,[WasShown]
      ,[OneOnScreen]
      ,[OneOnScreenId] 
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )  
	and ( NotifyDateTime >= @dstart ) 
	and ( NotifyDateTime < @dstop ) 
	order by NotifyDateTime desc
end
GO

-----------------------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

-----------------------------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------