if exists ( select * FROM sysobjects where id= object_id ( 'dbo.A_Clients__Save' ))
	Drop procedure dbo.A_Clients__Save
GO

Create procedure [dbo].[A_Clients__Save]
	@id	uniqueidentifier,
	@name 	nvarchar ( 200 ),
	@iduser	uniqueidentifier
as
begin
	Update A_Clients
	Set 	[Name] = @name,
		OwnerId = @iduser
	Where [Id] = @id

	if ( @@rowcount <= 0 )begin
		Insert Into A_Clients ( [Id], [Name], OwnerId )
		Values ( @id, @name, @iduser )
	end


	Update W_ClientRights 
	Set idowner = @iduser
	Where [idclient] = @id

	if ( @@rowcount <= 0 ) begin
		Insert Into W_ClientRights (idclient, idowner, canedit)
		Values ( @id, @iduser, 1 )

	end
	
end
GO


Insert into W_ClientRights (idclient, idowner, canedit)
	Select [id], [ownerid], 1
	From A_Clients 
	Where not exists ( Select idclient from W_ClientRights where idclient = id )
GO